"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var Hapi = require("hapi");
require("./Extensions");
var index_1 = require("./index");
var protoculture_1 = require("protoculture");
var HapiApp_1 = require("./HapiApp");
var HapiServiceProvider = (function (_super) {
    __extends(HapiServiceProvider, _super);
    function HapiServiceProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HapiServiceProvider.prototype.boot = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.bundle.container.bind(index_1.hapiSymbols.Server)
                    .toDynamicValue(function (context) {
                    var server = _this.createServer(context);
                    _this.initializePlugins(server, context);
                    _this.initializeConnections(server, context);
                    return server;
                })
                    .inSingletonScope();
                this.bindApp(HapiApp_1.HapiApp);
                this.bindConstructorParameter(index_1.hapiSymbols.Server, HapiApp_1.HapiApp, 0);
                this.bindConstructorParameter([index_1.hapiSymbols.Route], HapiApp_1.HapiApp, 1);
                return [2];
            });
        });
    };
    HapiServiceProvider.prototype.createServer = function (context) {
        var configurationOptions = {
            connections: {
                router: {
                    stripTrailingSlash: true,
                    isCaseSensitive: true,
                }
            }
        };
        try {
            var configuredOptions = context.container.get(index_1.hapiSymbols.ServerOptions);
            _.assign(configurationOptions, configuredOptions);
        }
        catch (error) {
        }
        return new Hapi.Server(configurationOptions);
    };
    HapiServiceProvider.prototype.initializeConnections = function (server, context) {
        var connections;
        try {
            connections = context.container.getAll(index_1.hapiSymbols.ServerConnectionOptions);
        }
        catch (error) {
            connections = [
                {
                    host: "0.0.0.0",
                    port: 80,
                }
            ];
        }
        _.chain(connections)
            .uniqBy(_.isEqual)
            .each(function (connection) { return server.connection(connection); })
            .value();
    };
    HapiServiceProvider.prototype.initializePlugins = function (server, context) {
        try {
            var plugins = context.container.getAll(index_1.hapiSymbols.Plugin);
            _.each(plugins, function (plugin) { return server.register(plugin); });
        }
        catch (error) {
        }
    };
    return HapiServiceProvider;
}(protoculture_1.ServiceProvider));
exports.HapiServiceProvider = HapiServiceProvider;
//# sourceMappingURL=HapiServiceProvider.js.map